diff -u -r nginx-0.8.49/src/http/ngx_http_parse.c nginx-0.8.49-modified/src/http/ngx_http_parse.c
--- nginx-0.8.49/src/http/ngx_http_parse.c	2010-06-23 09:34:54.000000000 -0700
+++ nginx-0.8.49-modified/src/http/ngx_http_parse.c	2010-08-11 16:32:06.000000000 -0700
@@ -1235,10 +1235,14 @@
                 break;
             }

-            return NGX_HTTP_PARSE_INVALID_REQUEST;
+            state = sw_usual;
+            *u++ = ch;
+            ch = *p++;
+            break;

         case sw_quoted_second:
             if (ch >= '0' && ch <= '9') {
+                r->quoted_uri = 1;
                 ch = (u_char) ((decoded << 4) + ch - '0');

                 if (ch == '%' || ch == '#') {
@@ -1257,6 +1261,7 @@

             c = (u_char) (ch | 0x20);
             if (c >= 'a' && c <= 'f') {
+                r->quoted_uri = 1;
                 ch = (u_char) ((decoded << 4) + c - 'a' + 10);

                 if (ch == '?') {
@@ -1273,7 +1278,10 @@
                 break;
             }

-            return NGX_HTTP_PARSE_INVALID_REQUEST;
+            state = sw_usual;
+            *u++ = ch;
+            ch = *p++;
+            break;
         }
     }
